#ifndef _GEEGROW_2WD_SPEED_DIFF_REGULTOR_H
#define _GEEGROW_2WD_SPEED_DIFF_REGULTOR_H
#include <Arduino.h>
#include "PidRegulator.h"
#include "DCMotor.h"
#include "OpticalEncoder.h"

//#define DEBUG_MODE

#define MIN_CORRECTION_LIMIT -100
#define MAX_CORRECTION_LIMIT 100

class DualWheelSpeedDifferenceRegulator {
	public:
		
		DualWheelSpeedDifferenceRegulator();
		DualWheelSpeedDifferenceRegulator(DCMotor* leftMotor, DCMotor* rightMotor, OpticalEncoder* leftEncoder, OpticalEncoder* rightEncoder);

		void attachLeftMotor(DCMotor* leftMotor);
		void attachRightMotor(DCMotor* rightMotor);
		void attachLeftOpticalEncoder(OpticalEncoder* leftEncoder);
		void attachRightOpticalEncoder(OpticalEncoder* rightEncoder);
		void setSpeedDifference(int8_t leftSpeed, int8_t rightSpeed);
		void setPidFactors(float Kp, float Ki, float Kd);
		void reset();
		void setDebugMode(char mode);
		void run();
		void setMotorSpeed(DCMotor* motor, int8_t speed);
		
	private:

		// Motors
		DCMotor* leftMotor;
		DCMotor* rightMotor;

		// Encoders
		OpticalEncoder* leftOpticalEncoder;
		OpticalEncoder* rightOpticalEncoder;

		PidRegulator* pidRegulator;

		int8_t leftSpeed = 0;
		int8_t rightSpeed = 0;
		
		void applyCorrection(int8_t correction);
};

#endif
