#ifndef _GEEGROW_2WD_SPEED_REGULTOR_H
#define _GEEGROW_2WD_SPEED_REGULTOR_H
#include <Arduino.h>
#include "PidRegulator.h"
#include "DCMotor.h"
#include "OpticalEncoder.h"

//#define DEBUG_MODE

#define MIN_CORRECTION_LIMIT -100
#define MAX_CORRECTION_LIMIT 100

class DualWheelSpeedRegulator {
	public:
		
		DualWheelSpeedRegulator();
		DualWheelSpeedRegulator(DCMotor* leftMotor, DCMotor* rightMotor, OpticalEncoder* leftEncoder, OpticalEncoder* rightEncoder);

		void attachLeftMotor(DCMotor* leftMotor);
		void attachRightMotor(DCMotor* rightMotor);
		void attachLeftOpticalEncoder(OpticalEncoder* leftEncoder);
		void attachRightOpticalEncoder(OpticalEncoder* rightEncoder);
		void setSpeed(int8_t speed);
		void setPidFactors(float Kp, float Ki, float Kd);
		void reset();
		void setDebugMode(char mode);
		void run();
		
	private:

		// Motors
		DCMotor* leftMotor;
		DCMotor* rightMotor;

		// Encoders
		OpticalEncoder* leftOpticalEncoder;
		OpticalEncoder* rightOpticalEncoder;

		PidRegulator* pidRegulator;

		int8_t speed = 0;
};

#endif
