#include <Wire.h>
#include <I2C.h>
#include <I2CTransport.h>
#include <PCA9685.h>
#include "I2CServo.h"

I2C myI2C = I2C();
I2CTransport transport = I2CTransport();

PCA9685 pwm =  PCA9685(0x40);

I2CServo servo = I2CServo(&pwm, 8, 540, 2400, 30, 400, 255);

void setup() {
	Serial.begin(9600);
	delay(1000);
	I2CTransport::setClient(&myI2C);
	I2CTransport::begin();

	pwm.begin();
	pwm.setPWMFreq(50);
	servo.begin(15);
 
	delay(1000);
	pwm.setRelPWM(0, 0);
	pwm.setRelPWM(1, 0);
	pwm.setRelPWM(2, 0);
	pwm.setRelPWM(3, 0);
	delay(2000);
}

void loop() {
    Serial.println("SmoothRotate: 0->180");
    servo.smoothRotate(0, 180);
    Chronos::delay(5000);

    Serial.println("SmoothRotate: 180->0");
    servo.smoothRotate(180, 0);
    Chronos::delay(5000);

    Serial.println("Rotate: 0->180");
    servo.rotate(180);
    Chronos::delay(5000);

    Serial.println("Rotate: 180->0");
    servo.rotate(0);
    Chronos::delay(5000);
}
